import org.gradle.api.tasks.testing.Test
import org.gradle.api.tasks.TaskAction


public class TestNGTask extends Test {
    String[] includedGroups = []
    String[] excludedGroups = []

    @TaskAction
    def runTests() {
        createConfiguration = { ig, eg ->
            return {
                includeGroups ig
                excludeGroups eg
                useDefaultListeners = false
                listeners << 'org.uncommons.reportng.HTMLReporter'
            }
        }
        options {
            jvmArgs "-Drun.mode=test"
            useTestNG(createConfiguration(includedGroups, excludedGroups))
            afterTest printTestStatus
        }
        executeTests()
    }
    
    def includeGroups(String... includeGroups) {
        includedGroups = includeGroups
    }

    def excludeGroups(String... excludeGroups) {
        excludedGroups = excludeGroups
    }
    
    def printTestStatus = { desc, result -> 
        println "Test ${result.resultType} ${desc.name} [${desc.className}] in ${(result.endTime-result.startTime)/1000}s"
    }
}
